diff --git a/doc/guides/rel_notes/release_18_11.rst b/doc/guides/rel_notes/release_18_11.rst
index 373dcc0..bbb0307 100644
--- a/doc/guides/rel_notes/release_18_11.rst
+++ b/doc/guides/rel_notes/release_18_11.rst
@@ -48,7 +48,7 @@ New Features
        - eventdev (lib, PMDs)
        - etc
      * Other libs
-     * Apps, Examples, Tools (if significative)
+     * Apps, Examples, Tools (if significant)
 
      This section is a comment. Do not overwrite or remove it.
      Also, make sure to start the actual text at the margin.
@@ -56,40 +56,42 @@ New Features
 
 * **Added support for using externally allocated memory in DPDK.**
 
-  DPDK has gained support for creating new ``rte_malloc`` heaps referencing
+  DPDK has added support for creating new ``rte_malloc`` heaps referencing
   memory that was created outside of DPDK's own page allocator, and using that
   memory natively with any other DPDK library or data structure.
 
-* **Added check for ensuring allocated memory addressable by devices.**
+* **Added check for ensuring allocated memory is addressable by devices.**
 
   Some devices can have addressing limitations so a new function,
-  ``rte_mem_check_dma_mask``, has been added for checking allocated memory is
-  not out of the device range. Because now memory can be dynamically allocated
-  after initialization, a dma mask is kept and any new allocated memory will be
-  checked out against that dma mask and rejected if out of range. If more than
-  one device has addressing limitations, the dma mask is the more restricted one.
+  ``rte_mem_check_dma_mask()``, has been added for checking that allocated
+  memory is not out of the device range. Since memory can now be allocated
+  dynamically after initialization, a DMA mask is stored and any new allocated
+  memory will be checked against it and rejected if it is out of range. If
+  more than one device has addressing limitations, the DMA mask is the more
+  restrictive one.
 
-* **Updated the C11 memory model version of ring library.**
+* **Updated the C11 memory model version of the ring library.**
 
-  The latency is decreased for architectures using the C11 memory model
-  version of the ring library.
+  Added changes to decrease latency for architectures using the C11 memory
+  model version of the ring library.
 
-  On Cavium ThunderX2 platform, the changes decreased latency by 27~29%
-  and 3~15% for MPMC and SPSC cases respectively (with 2 lcores). The
+  On Cavium ThunderX2 platform, the changes decreased latency by 27-29%
+  and 3-15% for MPMC and SPSC cases respectively (with 2 lcores). The
   real improvements may vary with the number of contending lcores and
-  the size of ring.
+  the size of the ring.
 
 * **Added hot-unplug handle mechanism.**
 
-  ``rte_dev_hotplug_handle_enable`` and ``rte_dev_hotplug_handle_disable`` are
-  for enabling or disabling hotplug handle mechanism.
+  Added ``rte_dev_hotplug_handle_enable()`` and
+  ``rte_dev_hotplug_handle_disable()`` for enabling or disabling the hotplug
+  handle mechanism.
 
-* **Support device multi-process hotplug.**
+* **Added support for device multi-process hotplug.**
 
-  Hotplug and hot-unplug for devices will now be supported in multiprocessing
-  scenario. Any ethdev devices created in the primary process will be regarded
-  as shared and will be available for all DPDK processes. Synchronization
-  between processes will be done using DPDK IPC.
+  Added support for hotplug and hot-unplug in a multiprocessing scenario. Any
+  ethdev devices created in the primary process will be regarded as shared and
+  will be available for all DPDK processes. Synchronization between processes
+  will be done using DPDK IPC.
 
 * **Added new Flow API actions to rewrite fields in packet headers.**
 
@@ -105,9 +107,10 @@ New Features
   Added new Flow API action to swap the source and destination MAC
   addresses in the outermost Ethernet header.
 
-* **Add support to offload more flow match and actions for CXGBE PMD**
+* **Add support to offload more flow match and actions for CXGBE PMD.**
 
-  Flow API support has been enhanced for CXGBE Poll Mode Driver to offload:
+  The Flow API support has been enhanced for the CXGBE Poll Mode Driver to
+  offload:
 
   * Match items: destination MAC address.
   * Action items: push/pop/rewrite vlan header,
@@ -116,6 +119,7 @@ New Features
     swap MAC addresses in outermost Ethernet header.
 
 * **Added a devarg to use the latest supported vector path in i40e.**
+
   A new devarg ``use-latest-supported-vec`` was introduced to allow users to
   choose the latest vector path that the platform supported. For example, users
   can use AVX2 vector path on BDW/HSW to get better performance.
@@ -133,8 +137,8 @@ New Features
 
 * **Added NXP ENETC PMD.**
 
-  Added the new enetc driver for NXP enetc platform. See the
-  "ENETC Poll Mode Driver" document for more details on this new driver.
+  Added the new enetc driver for the NXP enetc platform. See the
+  :doc:`../nics/enetc` nic driver guide for more details on this new driver.
 
 * **Added Ethernet poll mode driver for Aquantia aQtion family of 10G devices.**
 
@@ -147,17 +151,18 @@ New Features
   Updated the mlx5 driver including the following changes:
 
   * Improved security of PMD to prevent the NIC from getting stuck when
-    application misbehaves.
-  * reworked flow engine to supported e-switch flow rules (transfer attribute).
-  * Supported header re-write(L2-L4), VXLAN encap/decap, count ,match
+    the application misbehaves.
+  * Reworked flow engine to supported e-switch flow rules (transfer attribute).
+  * Added support for header re-write(L2-L4), VXLAN encap/decap, count, match
     on TCP flags and multiple flow groups with e-switch flow rules.
-  * Supported match on medatada, VXLAN and MPLS encap/decap with flow rules.
-  * Supported RTE_ETH_DEV_CLOSE_REMOVE flag to provide better support for
-    representors.
-  * Supported meson build.
+  * Added support for match on metadata, VXLAN and MPLS encap/decap with flow
+    rules.
+  * Added support for ``RTE_ETH_DEV_CLOSE_REMOVE`` flag to provide better
+    support for representors.
+  * Added support for meson build.
   * Fixed build issue with PPC.
-  * Supported BlueField VF.
-  * Supported externally allocated static memory for DMA.
+  * Added support for BlueField VF.
+  * Added support for externally allocated static memory for DMA.
 
 * **Updated Solarflare network PMD.**
 
@@ -173,36 +178,38 @@ New Features
 
   * Added AVX2-based vectorized Rx handler.
   * Added VLAN and checksum offloads to the simple Tx handler.
-  * Added the count flow action.
+  * Added the "count" flow action.
   * Enabled the virtual address IOVA mode.
 
-* **Updated failsafe driver.**
+* **Updated the failsafe driver.**
 
   Updated the failsafe driver including the following changes:
 
-  * Support for Rx and Tx queues start and stop.
-  * Support for Rx and Tx queues deferred start.
-  * Support for runtime Rx and Tx queues setup.
-  * Support multicast MAC address set.
+  * Added support for Rx and Tx queues start and stop.
+  * Added support for Rx and Tx queues deferred start.
+  * Added support for runtime Rx and Tx queues setup.
+  * Added support multicast MAC address set.
+
+* **Added a devarg to use a PCAP interface physical MAC address.**
 
-* **Added a devarg to use PCAP interface physical MAC address.**
-  A new devarg ``phy_mac`` was introduced to allow users to use physical
+  A new devarg ``phy_mac`` was introduced to allow users to use the physical
   MAC address of the selected PCAP interface.
 
 * **Added TAP Rx/Tx queues sharing with a secondary process.**
 
-  A secondary process can attach a TAP device created in the primary process,
-  probe the queues, and process Rx/Tx in a secondary process.
+  Added support to allow a secondary process to attach a TAP device created
+  in the primary process, probe the queues, and process Rx/Tx in a secondary
+  process.
 
 * **Added classification and metering support to SoftNIC PMD.**
 
   Added support for flow classification (rte_flow API), and metering and
   policing (rte_mtr API) to the SoftNIC PMD.
 
-* **Added Crypto support to Softnic PMD.**
+* **Added Crypto support to the Softnic PMD.**
 
   The Softnic is now capable of processing symmetric crypto workloads such
-  as cipher, cipher-authentication chaining, and aead encryption and
+  as cipher, cipher-authentication chaining, and AEAD encryption and
   decryption. This is achieved by calling DPDK Cryptodev APIs.
 
 * **Added cryptodev port to port library.**
@@ -212,12 +219,12 @@ New Features
 
 * **Added symmetric cryptographic actions to the pipeline library.**
 
-  In the pipeline library an added symmetric crypto action parsing and action
-  handler are implemented. The action allows automatically preparing the crypto
-  operation with the rules specified such as algorithm, key, and IV, etc for
-  the cryptodev port to process.
+  In the pipeline library support was added for symmetric crypto action
+  parsing and an action handler was implemented. The action allows automatic
+  preparation of the crypto operation with the rules specified such as
+  algorithm, key, and IV, etc. for the cryptodev port to process.
 
-* **Added support for GEN3 devices to Intel QAT driver .**
+* **Added support for GEN3 devices to Intel QAT driver.**
 
   Added support for the third generation of Intel QuickAssist devices.
 
@@ -225,26 +232,25 @@ New Features
 
   The QAT PMD was updated with additional support for:
 
-  * AES-CMAC algorithm.
+  * The AES-CMAC algorithm.
 
 * **Updated the AESNI MB PMD.**
 
-  The AESNI MB PMD has been updated with additional support for AES-GCM
-  algorithm support.
+  The AESNI MB PMD has been updated with additional support for the AES-GCM
+  algorithm.
 
 * **Added NXP CAAM JR PMD.**
 
   Added the new caam job ring driver for NXP platforms. See the
-  "NXP CAAM JOB RING (caam_jr)" document for more details on this new driver.
+  :doc:`../cryptodevs/caam_jr` document for more details on this new driver.
 
 * **Added support for Dynamic Huffman Encoding to Intel QAT comp PMD.**
 
   The Intel QuickAssist (QAT) compression PMD has been updated with support
   for Dynamic Huffman Encoding for the Deflate algorithm.
-
 * **Added Event Ethernet Tx Adapter.**
 
-  Added event ethernet Tx adapter library that  provides configuration and
+  Added event ethernet Tx adapter library that provides configuration and
   data path APIs for the ethernet transmit stage of an event driven packet
   processing application. These APIs abstract the implementation of the
   transmit stage and allow the application to use eventdev PMD support or
@@ -260,23 +266,23 @@ New Features
 
 * **Added extendable bucket feature to hash library (rte_hash).**
 
-  This new “extendable bucket” feature provides 100% insertion guarantee to
+  This new "extendable bucket" feature provides 100% insertion guarantee to
   the capacity specified by the user by extending hash table with extra
   buckets when needed to accommodate the unlikely event of intensive hash
-  collisions.  In addition, the internal hashing algorithm was changed to use
+  collisions. In addition, the internal hashing algorithm was changed to use
   partial-key hashing to improve memory efficiency and lookup performance.
 
 * **Added lock free reader/writer concurrency to hash library (rte_hash).**
 
   Lock free reader/writer concurrency prevents the readers from getting
-  blocked due to a pre-empted writer thread. This allows the hash library
-  to be used in scenarios where the writer thread runs on control plane.
+  blocked due to a preempted writer thread. This allows the hash library
+  to be used in scenarios where the writer thread runs on the control plane.
 
-* **Added Traffic Pattern Aware Power Control Library**
+* **Added Traffic Pattern Aware Power Control Library.**
 
-  Added an experimental library. This extend Power Library and provide
-  empty_poll APIs. This feature measure how many times empty_poll are
-  executed per core, use the number of empty polls as a hint for system
+  Added an experimental library that extends the Power Library and provides
+  empty_poll APIs. This feature measures how many times empty_polls are
+  executed per core and uses the number of empty polls as a hint for system
   power management.
 
   See the :doc:`../prog_guide/power_man` section of the DPDK Programmers
@@ -292,27 +298,27 @@ New Features
 
 * **Added Telemetry API.**
 
-  Added the telemetry API which allows applications to transparently expose
-  their telemetry via a UNIX socket in JSON. The JSON can be consumed by any
+  Added a new telemetry API which allows applications to transparently expose
+  their telemetry in JSON via a UNIX socket. The JSON can be consumed by any
   Service Assurance agent, such as CollectD.
 
 * **Updated KNI kernel module, rte_kni library, and KNI sample application.**
 
   Updated the KNI kernel module with a new kernel module parameter,
   ``carrier=[on|off]`` to allow the user to control the default carrier
-  state of KNI kernel network interfaces.  The default carrier state
+  state of the KNI kernel network interfaces. The default carrier state
   is now set to ``off``, so the interfaces cannot be used until the
   carrier state is set to ``on`` via ``rte_kni_update_link`` or
   by writing ``1`` to ``/sys/devices/virtual/net/<iface>/carrier``.
   In previous versions the default carrier state was left undefined.
   See :doc:`../prog_guide/kernel_nic_interface` for more information.
 
-  Added the new API function ``rte_kni_update_link`` to allow the user
+  Also added the new API function ``rte_kni_update_link()`` to allow the user
   to set the carrier state of the KNI kernel network interface.
 
-  Added a new command line flag ``-m`` to the KNI sample application to
+  Also added a new command line flag ``-m`` to the KNI sample application to
   monitor and automatically reflect the physical NIC carrier state to the
-  KNI kernel network interface with the new ``rte_kni_update_link`` API.
+  KNI kernel network interface with the new ``rte_kni_update_link()`` API.
   See :doc:`../sample_app_ug/kernel_nic_interface` for more information.
 
 * **Added ability to switch queue deferred start flag on testpmd app.**
@@ -322,7 +328,7 @@ New Features
   the specified port. The port must be stopped before the command call in order
   to reconfigure queues.
 
-* **Add a new sample for vDPA**
+* **Add a new sample application for vDPA.**
 
   The vdpa sample application creates vhost-user sockets by using the
   vDPA backend. vDPA stands for vhost Data Path Acceleration which utilizes
@@ -337,12 +343,12 @@ New Features
   computation to the NIST Cryptographic Algorithm Validation Program (CAVP)
   test vectors.
 
-* **Allow unit test binary to take parameters from the environment**
+* **Allow unit test binary to take parameters from the environment.**
 
   The unit test "test", or "dpdk-test", binary is often called from scripts,
-  which can make passing additional parameters, such as a coremask, to it more
-  awkward. Support has been added to the application to allow it to take
-  additional command-line parameter values from the "DPDK_TEST_PARAMS"
+  which can make passing additional parameters, such as a coremask,
+  difficult. Support has been added to the application to allow it to take
+  additional command-line parameter values from the ``DPDK_TEST_PARAMS``
   environment variable to make this application easier to use.
 
 
@@ -364,13 +370,14 @@ API Changes
   for any users of memseg-walk-related functions, as they will now have to skip
   externally allocated segments in most cases if the intent is to only iterate
   over internal DPDK memory.
-  ``socket_id`` parameter across the entire DPDK has gained additional meaning,
-  as some socket ID's will now be representing externally allocated memory. No
-  changes will be required for existing code as backwards compatibility will be
-  kept, and those who do not use this feature will not see these extra socket
-  ID's. Any new API's must not check socket ID parameters themselves, and must
-  instead leave it to the memory subsystem to decide whether socket ID is a
-  valid one.
+
+  In addition the ``socket_id`` parameter across the entire DPDK has gained
+  additional meaning, as some socket ID's will now be representing externally
+  allocated memory. No changes will be required for existing code as backwards
+  compatibility will be kept, and those who do not use this feature will not
+  see these extra socket ID's. Any new API's must not check socket ID
+  parameters themselves, and must instead leave it to the memory subsystem to
+  decide whether socket ID is a valid one.
 
 * eal: The following devargs functions, which were deprecated in 18.05,
   were removed in 18.11:
@@ -387,8 +394,8 @@ API Changes
   ``rte_dev_remove`` or ``rte_eal_hotplug_remove``.
 
 * eal: The scope of ``rte_eal_hotplug_add()``/``rte_dev_probe()``
-  and ``rte_eal_hotplug_remove()``/``rte_dev_remove()`` is extended.
-  In multi-process model, they will guarantee that the device is
+  and ``rte_eal_hotplug_remove()``/``rte_dev_remove()`` has been extended.
+  In the multi-process model, they will guarantee that the device is
   attached or detached on all processes.
 
 * mbuf: The ``__rte_mbuf_raw_free()`` and ``__rte_pktmbuf_prefree_seg()``
@@ -396,42 +403,43 @@ API Changes
   ``rte_mbuf_raw_free()`` and ``rte_pktmbuf_prefree_seg()``.
 
 * ethdev: The deprecated functions attach/detach were removed in 18.11.
-  ``rte_eth_dev_attach`` can be replaced by ``RTE_ETH_FOREACH_MATCHING_DEV``
-  and ``rte_dev_probe`` or ``rte_eal_hotplug_add``.
-  ``rte_eth_dev_detach`` can be replaced by
-  ``rte_dev_remove`` or ``rte_eal_hotplug_remove``.
+  ``rte_eth_dev_attach()`` can be replaced by ``RTE_ETH_FOREACH_MATCHING_DEV``
+  and ``rte_dev_probe()`` or ``rte_eal_hotplug_add()``.
+  ``rte_eth_dev_detach()`` can be replaced by
+  ``rte_dev_remove()`` or ``rte_eal_hotplug_remove()``.
 
 * ethdev: A call to ``rte_eth_dev_release_port()`` has been added in
   ``rte_eth_dev_close()``. As a consequence, a closed port is freed
   and seen as invalid because of its state ``RTE_ETH_DEV_UNUSED``.
-  This new behaviour is enabled per driver for a migration period.
+  This new behavior is enabled per driver for a migration period.
 
-* A new device flag, RTE_ETH_DEV_NOLIVE_MAC_ADDR, changes the order of
-  actions inside rte_eth_dev_start regarding MAC set. Some NICs do not
+* A new device flag, ``RTE_ETH_DEV_NOLIVE_MAC_ADDR``, changes the order of
+  actions inside ``rte_eth_dev_start()`` regarding MAC set. Some NICs do not
   support MAC changes once the port has started and with this new device
   flag the MAC can be properly configured in any case. This is particularly
   important for bonding.
 
-* The default behaviour of CRC strip offload changed. Without any specific Rx
-  offload flag, default behavior by PMD is now to strip CRC.
-  DEV_RX_OFFLOAD_CRC_STRIP offload flag has been removed.
-  To request keeping CRC, application should set ``DEV_RX_OFFLOAD_KEEP_CRC`` Rx
-  offload.
+* The default behavior of CRC strip offload has changed in this
+  release. Without any specific Rx offload flag, default behavior by a PMD is
+  now to strip CRC. ``DEV_RX_OFFLOAD_CRC_STRIP`` offload flag has been removed.
+  To request keeping CRC, application should set ``DEV_RX_OFFLOAD_KEEP_CRC``
+  Rx offload.
 
-* eventdev: Type of 2nd parameter to ``rte_event_eth_rx_adapter_caps_get()``
-  has been changed from uint8_t to uint16_t.
+* eventdev: The type of the second parameter to
+  ``rte_event_eth_rx_adapter_caps_get()`` has been changed from uint8_t to
+  uint16_t.
 
 * kni: By default, interface carrier status is ``off`` which means there won't
-  be any traffic. It can be set to ``on`` via ``rte_kni_update_link()`` API
-  or via ``sysfs`` interface:
-  ``echo 1 > /sys/class/net/vEth0/carrier``.
+  be any traffic. It can be set to ``on`` via ``rte_kni_update_link()`` API or
+  via ``sysfs`` interface: ``echo 1 > /sys/class/net/vEth0/carrier``.
+
   Note interface should be ``up`` to be able to read/write sysfs interface.
   When KNI sample application is used, ``-m`` parameter can be used to
   automatically update the carrier status for the interface.
 
-* kni: When ethtool support enabled (``CONFIG_RTE_KNI_KMOD_ETHTOOL=y``)
-  ethtool commands ``ETHTOOL_GSET & ETHTOOL_SSET`` are no more supported for the
-  kernels that has ``ETHTOOL_GLINKSETTINGS & ETHTOOL_SLINKSETTINGS`` support.
+* kni: When ethtool support is enabled (``CONFIG_RTE_KNI_KMOD_ETHTOOL=y``)
+  ethtool commands ``ETHTOOL_GSET & ETHTOOL_SSET`` are no longer supported for
+  kernels that have ``ETHTOOL_GLINKSETTINGS & ETHTOOL_SLINKSETTINGS`` support.
   This means ``ethtool "-a|--show-pause", "-s|--change"`` won't work, and
   ``ethtool <iface>`` output will have less information.
 
@@ -451,42 +459,30 @@ ABI Changes
    =========================================================
 
 * eal: added ``legacy_mem`` and ``single_file_segments`` values to
-       ``rte_config`` structure on account of improving DPDK usability when
-       using either ``--legacy-mem`` or ``--single-file-segments`` flags.
+  ``rte_config`` structure on account of improving DPDK usability when
+  using either ``--legacy-mem`` or ``--single-file-segments`` flags.
 
 * eal: EAL library ABI version was changed due to previously announced work on
-       supporting external memory in DPDK:
-         - structure ``rte_memseg_list`` now has a new field indicating length
-           of memory addressed by the segment list
-         - structure ``rte_memseg_list`` now has a new flag indicating whether
-           the memseg list refers to external memory
-         - structure ``rte_malloc_heap`` now has a new field indicating socket
-           ID the malloc heap belongs to
-         - structure ``rte_mem_config`` has had its ``malloc_heaps`` array
-           resized from ``RTE_MAX_NUMA_NODES`` to ``RTE_MAX_HEAPS`` value
-         - structure ``rte_malloc_heap`` now has a ``heap_name`` member
-         - structure ``rte_eal_memconfig`` has been extended to contain next
-           socket ID for externally allocated segments
-
-* eal: Added ``dma_maskbits`` to ``rte_mem_config`` for keeping more restricted
-       dma mask based on devices addressing limitations.
+  supporting external memory in DPDK:
 
-* eal: The structure ``rte_device`` got a new field to reference a ``rte_bus``.
-  It is changing the size of the ``struct rte_device`` and the inherited
-  device structures of all buses.
+  - Structure ``rte_memseg_list`` now has a new field indicating length
+    of memory addressed by the segment list
+  - Structure ``rte_memseg_list`` now has a new flag indicating whether
+    the memseg list refers to external memory
+  - Structure ``rte_malloc_heap`` now has a new field indicating socket
+    ID the malloc heap belongs to
+  - Structure ``rte_mem_config`` has had its ``malloc_heaps`` array
+    resized from ``RTE_MAX_NUMA_NODES`` to ``RTE_MAX_HEAPS`` value
+  - Structure ``rte_malloc_heap`` now has a ``heap_name`` member
+  - Structure ``rte_eal_memconfig`` has been extended to contain next
+    socket ID for externally allocated segments
 
+* eal: Added ``dma_maskbits`` to ``rte_mem_config`` for keeping the most
+  restrictive DMA mask based on the devices addressing limitations.
 
-Removed Items
--------------
-
-.. This section should contain removed items in this release. Sample format:
-
-   * Add a short 1-2 sentence description of the removed item
-     in the past tense.
-
-   This section is a comment. Do not overwrite or remove it.
-   Also, make sure to start the actual text at the margin.
-   =========================================================
+* eal: The structure ``rte_device`` has a new field to reference a
+  ``rte_bus``.  It thus changes the size of the ``struct rte_device`` and the
+  inherited device structures of all buses.
 
 
 Shared Library Versions
@@ -578,22 +574,24 @@ Known Issues
    Also, make sure to start the actual text at the margin.
    =========================================================
 
-* When using SR-IOV (VF) support with netvsc PMD and the Mellanox mlx5 bifurcated
-  driver; the Linux netvsc device must be brought up before the netvsc device is
-  unbound and passed to the DPDK.
+* When using SR-IOV (VF) support with netvsc PMD and the Mellanox mlx5
+  bifurcated driver the Linux netvsc device must be brought up before the
+  netvsc device is unbound and passed to the DPDK.
 
-* IBM Power8 is not supported by this release of DPDK. IBM Power9 is supported.
+* IBM Power8 is not supported in this release of DPDK. IBM Power9 is
+  supported.
 
-* ``AVX-512`` support has been disabled for ``GCC`` builds [1] because of a crash [2].
-  This can affect ``native`` machine type build targets on the platforms that support
-  ``AVX512F`` like ``Intel Skylake`` processors, and can cause a possible performance drop.
-  The immediate workaround is to use ``clang`` compiler on these platforms.
-  Issue has been identified as a GCC defect and reported to GCC community [3]. Further
-  actions will be taken based on the GCC defect result.
+* ``AVX-512`` support has been disabled for ``GCC`` builds [1] because of a
+  crash [2]. This can affect ``native`` machine type build targets on the
+  platforms that support ``AVX512F`` like ``Intel Skylake`` processors, and
+  can cause a possible performance drop. The immediate workaround is to use
+  ``clang`` compiler on these platforms. The issue has been identified as a
+  GCC defect and reported to the GCC community [3]. Further actions will be
+  taken based on the GCC defect result.
 
-  [1]: Commit 8d07c82b239f ("mk: disable gcc AVX512F support")
-  [2]: https://bugs.dpdk.org/show_bug.cgi?id=97
-  [3]: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=88096
+  * [1]: Commit 8d07c82b239f ("mk: disable gcc AVX512F support")
+  * [2]: https://bugs.dpdk.org/show_bug.cgi?id=97
+  * [3]: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=88096
 
 
 Tested Platforms
@@ -661,7 +659,7 @@ Tested Platforms
        * Device id (pf/vf): 8086:1572 / 8086:154c
        * Driver version: 2.4.6 (i40e)
 
-     * Intel Corporation Ethernet Connection X722 for 10GbE SFP+ (4x10G)
+     * Intel(R) Corporation Ethernet Connection X722 for 10GbE SFP+ (4x10G)
 
        * Firmware version: 3.33 0x80000fd5 0.0.0
        * Device id (pf/vf): 8086:37d0 / 8086:37cd